// Citizen2.m 

// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.


#import "Citizen2.h"
#import <random.h>
#import <math.h>
#import "LataneGrid.h"


@implementation Citizen2

- considerOpinion
{
  BOOL agentMoved = NO;
  opinion = 1;      
  periodsOpinion++;
  if ( movement == YES )
    {
      int xx = x;
      int yy = y;
      double newPressure = pressureHere;

      agentMoved = [self scoutLocationX: &xx Y: &yy Discontent: &newPressure];    
      if (agentMoved == YES)
	{   
	  xlag = x;
	  ylag = y;
	  x = xx;
	  y = yy;
	  pressureHere = newPressure;
	   
	  if ( opinionlag1 == 1 ){
	    [opinionGrid removeOpinion: opinion Persuasion: persuas Support: support AtX: xlag Y: ylag Type: citizenType];
	  }

#ifndef NOPOSGRID
	  [positionGrid deleteObject: self atX: xlag Y: ylag];
	  
	  [positionGrid add: self atX: x Y: y];
#endif
	  //[opinionGrid movePersonFromX: xlag Y: ylag ToX: x Y: y];
	  [opinionGrid addOpinion: opinion Persuasion: persuas Support: support AtX: x Y: y Type: citizenType];
	}
      else
	{
	  //don't need to do anything if opinionlag1==1
	  if (opinionlag1 == 0)
	    {
	      [opinionGrid addOpinion: opinion Persuasion: persuas Support: support AtX: x Y: y Type: citizenType]; 
	    }
	}
    }
  else 
    //a model with no movement which means this guy only needs to be turned on once
    {
      if (opinionlag1 == 0)
	{
	  [opinionGrid addOpinion: opinion Persuasion: persuas Support: support AtX: x Y: y Type: citizenType]; 
	}
    }
  return self; 
}

@end

























