//MyArguments.h



// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.

#import <defobj/Arguments.h>

id
makeProbe (id obj, const char *ivarName);

double
getDouble (id obj, const char *ivarName);

int
getInt (id obj, const char *ivarName);


@interface MyArguments: Arguments_c
 {
   int citizensMove;
   int worldXSize,worldYSize;
   int visionRadius,numPPL, numPTwo;
   int randomSeed;
   int run;
   int duration;
   BOOL wrapAround;
   BOOL SYNCHRONOUS;
   BOOL RANDOMIZED;
   BOOL GUIshots;
   BOOL UNATTENDED;

   double probYES;
 
   const char *numPTwoArg;
   
   char *charDate ;
 
 }

- (BOOL)getWrapAround;

- (BOOL)getSYNCHRONOUS;
- (BOOL)getRANDOMIZED;

- (int)getRunArg;
- sayHello;

@end















